| The Gaudi Framework v29r0 (ff2e7097)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Private Member Functions | Private Attributes | List of all members
Genfun::GaudiMathImplementation::GSLFunctionWithMode Class Reference

mandatory macro from CLHEP/GenericFunctions More...

`#include <GaudiMath/GSLFunAdapters.h>`

Inheritance diagram for Genfun::GaudiMathImplementation::GSLFunctionWithMode:
[legend]
Collaboration diagram for Genfun::GaudiMathImplementation::GSLFunctionWithMode:
[legend]

## Public Types
typedef double(* | Function) (double, gsl_mode_t)
| the actual type of the function More...

## Public Member Functions
| GSLFunctionWithMode (Function fun, const gsl_mode_t &mode)
| mandatory macro from CLHEP/GenericFunctions More...
| GSLFunctionWithMode (const GSLFunctionWithMode &)
| copy constructor More...
| ~GSLFunctionWithMode () override=default
| destructor More...
double | operator() (double x) const override
| the main method More...
double | operator() (const Argument &x) const override
bool | hasAnalyticDerivative () const override
unsigned int | dimensionality () const override
Genfun::Derivative | partial (unsigned int i) const override
Function | function () const
| get the function itself More...
const gsl_mode_t & | mode () const
| get the current mode More...

## Private Member Functions
| GSLFunctionWithMode ()
GSLFunctionWithMode & | operator= (const GSLFunctionWithError &)

## Private Attributes
Function | m_function
std::unique_ptr< gsl_mode_t > | m_mode

## Detailed Description

mandatory macro from CLHEP/GenericFunctions

Definition at line 83 of file GSLFunAdapters.h.

## Member Typedef Documentation

typedef double( * Genfun::GaudiMathImplementation::GSLFunctionWithMode::Function) (double, gsl_mode_t)

the actual type of the function

Definition at line 87 of file GSLFunAdapters.h.

## Constructor & Destructor Documentation

Genfun::GaudiMathImplementation::GSLFunctionWithMode::GSLFunctionWithMode | ( | GSLFunctionWithMode::Function | function,
|  | const gsl_mode_t & | mode
| ) |  |

mandatory macro from CLHEP/GenericFunctions

constructor with pointer to function

Definition at line 69 of file GSLFunAdapters.cpp.

70 : AbsFunction(), m_function( function ), m_mode( std::make_unique<gsl_mode_t>( mod ) )
71 {
72 }
Gaudi.CommonGaudiConfigurables.mod
mod
Definition: CommonGaudiConfigurables.py:22
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
std::unique_ptr< gsl_mode_t > m_mode
Definition: GSLFunAdapters.h:118
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:117

Genfun::GaudiMathImplementation::GSLFunctionWithMode::GSLFunctionWithMode | ( | const GSLFunctionWithMode & | func | ) |

copy constructor

Definition at line 74 of file GSLFunAdapters.cpp.

75 : AbsFunction(), m_function( func.m_function ), m_mode( std::make_unique<gsl_mode_t>( *( func.m_mode ) ) )
76 {
77 }
GaudiPluginService.cpluginsvc.func
func
Definition: cpluginsvc.py:229
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
std::unique_ptr< gsl_mode_t > m_mode
Definition: GSLFunAdapters.h:118
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:117

Genfun::GaudiMathImplementation::GSLFunctionWithMode::~GSLFunctionWithMode | ( |  | ) |
| override default

destructor

Genfun::GaudiMathImplementation::GSLFunctionWithMode::GSLFunctionWithMode | ( |  | ) |
| private

## Member Function Documentation

unsigned int Genfun::GaudiMathImplementation::GSLFunctionWithMode::dimensionality | ( |  | ) | const
| inline override

Definition at line 103 of file GSLFunAdapters.h.

103 { return 1; }

GSLFunctionWithMode::Function Genfun::GaudiMathImplementation::GSLFunctionWithMode::function | ( |  | ) | const

get the function itself

Definition at line 96 of file GSLFunAdapters.cpp.

96 { return m_function; }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:117

bool Genfun::GaudiMathImplementation::GSLFunctionWithMode::hasAnalyticDerivative | ( |  | ) | const
| inline override

Definition at line 102 of file GSLFunAdapters.h.

102 { return true; }

const gsl_mode_t & Genfun::GaudiMathImplementation::GSLFunctionWithMode::mode | ( |  | ) | const

get the current mode

Definition at line 98 of file GSLFunAdapters.cpp.

98 { return *m_mode; }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
std::unique_ptr< gsl_mode_t > m_mode
Definition: GSLFunAdapters.h:118

double Genfun::GaudiMathImplementation::GSLFunctionWithMode::operator() | ( | double | x | ) | const
| override

the main method

Definition at line 79 of file GSLFunAdapters.cpp.

79 { return ( *m_function )( x, *m_mode ); }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
std::unique_ptr< gsl_mode_t > m_mode
Definition: GSLFunAdapters.h:118
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:117

double Genfun::GaudiMathImplementation::GSLFunctionWithMode::operator() | ( | const Argument & | x | ) | const
| override

GSLFunctionWithMode& Genfun::GaudiMathImplementation::GSLFunctionWithMode::operator= | ( | const GSLFunctionWithError & |  | ) |
| private

Genfun::Derivative Genfun::GaudiMathImplementation::GSLFunctionWithMode::partial | ( | unsigned int | i | ) | const
| override

Definition at line 86 of file GSLFunAdapters.cpp.

87 {
88 if ( i >= 1 ) {
89 const AbsFunction& aux = GaudiMath::Constant( 0, 1 );
90 return Genfun::FunctionNoop( &aux );
91 };
92 const AbsFunction& aux = GaudiMath::Derivative( *this, i );
93 return Genfun::FunctionNoop( &aux );
94 }
GaudiMath::Derivative
Genfun::GaudiMathImplementation::NumericalDerivative Derivative
Definition: GaudiMath.h:27
GaudiMath::Constant
Genfun::GaudiMathImplementation::Constant Constant
Definition: GaudiMath.h:26

## Member Data Documentation

Function Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
| private

Definition at line 117 of file GSLFunAdapters.h.

std::unique_ptr<gsl_mode_t> Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
| private

Definition at line 118 of file GSLFunAdapters.h.

The documentation for this class was generated from the following files:

- GaudiGSL/GaudiMath/GSLFunAdapters.h
- GaudiGSL/src/Lib/GSLFunAdapters.cpp